stages:
  - test
  - deploy

UnitTest:
  image: python:3.6
  stage: test
  before_script:
    - wget -q -O - https://dl-ssl.google.com/linux/linux_signing_key.pub | apt-key add -
    - echo "deb http://dl.google.com/linux/chrome/deb/ stable main" > /etc/apt/sources.list.d/google.list
    - sudo apt -y -qq update && sudo apt -y -qq install python3-pip
    - pip3 install -r requirements.txt
    - python3 manage.py makemigrations
    - python3 manage.py migrate
    - apt-get update -qq && apt-get install -y -qq unzip
    - apt-get install -y google-chrome-stable
    - apt-get install -y xvfb
    - wget https://chromedriver.storage.googleapis.com/78.0.3904.70/chromedriver_linux64.zip
    - unzip chromedriver_linux64.zip
    - chmod +x chromedriver
    - mv -f chromedriver /usr/local/bin/chromedriver
    - python3 manage.py collectstatic --no-input
  when: on_success
  script:
    - coverage run --include='ppw/*' manage.py test
    - coverage report -m

Deployment:
  image: ruby:2.4
  stage: deploy
  before_script:
    - gem install dpl
    - wget -qO- https://cli-assets.heroku.com/install-ubuntu.sh | sh
  script:
    - dpl --provider=heroku --app=$HEROKU_APPNAME --api-key=$HEROKU_APIKEY
    - export HEROKU_API_KEY=$HEROKU_APIKEY
    - heroku run --app $HEROKU_APPNAME python manage.py migrate
  environment:
    name: production
    url: $HEROKU_APP_HOST
